#region File Header
// /////////////////////////////////////////////////////////////
// File: RenderLabel.cs	Class: Kennedy.Windows.ControlsTricks.Controls.RenderLabel
// Date: 3/20/2004		Author: Michael Kennedy
// Language: C#			Framework: .NET
//
// Copyright: Copyright (c) Michael Kennedy, 2004
// /////////////////////////////////////////////////////////////
// License: See License.txt file included with application.
// /////////////////////////////////////////////////////////////
#endregion

using System;
using System.Windows.Forms;

namespace Kennedy.Windows.ControlsTricks.Controls
{
	/// <summary>
	///		This label uses the SetStyle method to enable double buffering
	///		in GDI+. This gives us a truly flicker-free rendering surface.
	///		We can then override the paint event for this class and do our
	///		custom rendering there.
	///		
	///		Note that the SetStyle method only works in the constructor
	///		of the class you're applying it to.
	/// </summary>
	public class RenderLabel : System.Windows.Forms.Label
	{
		public RenderLabel()
		{
			SetStyle(ControlStyles.UserPaint, true);
			SetStyle(ControlStyles.AllPaintingInWmPaint, true);
			SetStyle(ControlStyles.DoubleBuffer, true);
			SetStyle(ControlStyles.ResizeRedraw, true);
		}
	}
}
