#region File Header
// /////////////////////////////////////////////////////////////
// File: FullScreenForm.cs	Class: Kennedy.Windows.ControlsTricks.Forms.FullScreenForm
// Date: 3/20/2004			Author: Michael Kennedy
// Language: C#				Framework: .NET
//
// Copyright: Copyright (c) Michael Kennedy, 2004
// /////////////////////////////////////////////////////////////
// License: See License.txt file included with application.
// /////////////////////////////////////////////////////////////
#endregion

using System;
using System.Drawing;
using System.Windows.Forms;

namespace Kennedy.Windows.ControlsTricks.Forms
{
	public class FullScreenForm : System.Windows.Forms.Form
	{
		#region Member Variables

		private System.ComponentModel.Container components = null;
		private Kennedy.Windows.ControlsTricks.Controls.ProcessingControl processControl = null;

		#endregion

		#region Construction and Cleanup

		public FullScreenForm(Kennedy.Windows.ControlsTricks.Controls.ProcessingControl processControl)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// Add any constructor code after InitializeComponent call
			//
			this.AddControl(processControl);

			int width = Screen.PrimaryScreen.Bounds.Width;
			int height = Screen.PrimaryScreen.Bounds.Height;

			this.Location = new Point(0, 0);
			this.Size = new Size(width, height);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#endregion

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			// 
			// FullScreenForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 266);
			this.Cursor = System.Windows.Forms.Cursors.Cross;
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.None;
			this.KeyPreview = true;
			this.Name = "FullScreenForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.Manual;
			this.Text = "FullScreenForm";
			this.TopMost = true;
			this.KeyDown += new System.Windows.Forms.KeyEventHandler(this.FullScreenForm_KeyDown);

		}
		#endregion

		#region Windows Forms Event Handlers

		private void FullScreenForm_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			if (e.KeyCode == Keys.Escape)
			{
				e.Handled = true;

				this.DialogResult = DialogResult.OK;
				this.Close();
			}
		}

		#endregion

		#region Control Management Code

		public void AddControl(Kennedy.Windows.ControlsTricks.Controls.ProcessingControl processControl)
		{
			if (this.processControl != null)
			{
				throw new Exception("Cannot add two controls at one time.");
			}

			this.processControl = processControl;
			processControl.Dock = DockStyle.Fill;

			this.Controls.Add(processControl);
			processControl.Visible = true;
		}

		#endregion

	}
}
