#region File Header
// /////////////////////////////////////////////////////////////
// File: MainForm.cs	Class: Kennedy.Windows.ControlsTricks.Forms.MainForm
// Date: 3/20/2004		Author: Michael Kennedy
// Language: C#			Framework: .NET
//
// Copyright: Copyright (c) Michael Kennedy, 2004
// /////////////////////////////////////////////////////////////
// License: See License.txt file included with application.
// /////////////////////////////////////////////////////////////
#endregion

using System;
using System.Drawing;
using System.Windows.Forms;

namespace Kennedy.Windows.ControlsTricks.Forms
{
	/// <summary>
	///		This class is the main Windows Form for the sample
	///		application. The primary principle it demonstrates is
	///		the sharing of the render control processingControl.
	///		
	///		This is accomplished an active, running control back
	///		and forth between two forms without any noticable issues
	///		for render control (e.g. view resetting or lag time).
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		#region Member Variables

		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.StatusBar statusBar1;
		private System.Windows.Forms.Label labelDivider;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.LinkLabel linkLabelExit;
		private System.Windows.Forms.LinkLabel linkLabelAbout;

		private Kennedy.Windows.ControlsTricks.Controls.ProcessingControl processingControl;
		private System.Windows.Forms.LinkLabel linkLabelFulLScreen;
		private System.Windows.Forms.LinkLabel linkLabelPopOffOn;
		private Kennedy.Windows.ControlsTricks.Forms.PopOffForm popOffForm = null;
		private bool messagedOnce = false;

		#endregion

		#region Construction and Cleanup

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#endregion

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MainForm));
			this.processingControl = new Kennedy.Windows.ControlsTricks.Controls.ProcessingControl();
			this.statusBar1 = new System.Windows.Forms.StatusBar();
			this.labelDivider = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.linkLabelExit = new System.Windows.Forms.LinkLabel();
			this.linkLabelAbout = new System.Windows.Forms.LinkLabel();
			this.linkLabelFulLScreen = new System.Windows.Forms.LinkLabel();
			this.linkLabelPopOffOn = new System.Windows.Forms.LinkLabel();
			this.SuspendLayout();
			// 
			// processingControl
			// 
			this.processingControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.processingControl.Location = new System.Drawing.Point(0, 28);
			this.processingControl.Name = "processingControl";
			this.processingControl.Size = new System.Drawing.Size(360, 288);
			this.processingControl.TabIndex = 3;
			// 
			// statusBar1
			// 
			this.statusBar1.Location = new System.Drawing.Point(0, 316);
			this.statusBar1.Name = "statusBar1";
			this.statusBar1.Size = new System.Drawing.Size(360, 22);
			this.statusBar1.TabIndex = 4;
			// 
			// labelDivider
			// 
			this.labelDivider.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.labelDivider.BackColor = System.Drawing.SystemColors.Highlight;
			this.labelDivider.Location = new System.Drawing.Point(0, 28);
			this.labelDivider.Name = "labelDivider";
			this.labelDivider.Size = new System.Drawing.Size(368, 1);
			this.labelDivider.TabIndex = 6;
			// 
			// label1
			// 
			this.label1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.label1.BackColor = System.Drawing.Color.White;
			this.label1.Cursor = System.Windows.Forms.Cursors.Hand;
			this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 14F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.ForeColor = System.Drawing.SystemColors.Highlight;
			this.label1.Location = new System.Drawing.Point(72, 0);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(188, 28);
			this.label1.TabIndex = 5;
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// linkLabelExit
			// 
			this.linkLabelExit.BackColor = System.Drawing.Color.White;
			this.linkLabelExit.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.linkLabelExit.LinkBehavior = System.Windows.Forms.LinkBehavior.HoverUnderline;
			this.linkLabelExit.Location = new System.Drawing.Point(0, 0);
			this.linkLabelExit.Name = "linkLabelExit";
			this.linkLabelExit.Size = new System.Drawing.Size(36, 28);
			this.linkLabelExit.TabIndex = 2;
			this.linkLabelExit.TabStop = true;
			this.linkLabelExit.Text = "Exit";
			this.linkLabelExit.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			this.linkLabelExit.VisitedLinkColor = System.Drawing.Color.Blue;
			this.linkLabelExit.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.linkLabelExit_LinkClicked);
			// 
			// linkLabelAbout
			// 
			this.linkLabelAbout.BackColor = System.Drawing.Color.White;
			this.linkLabelAbout.LinkBehavior = System.Windows.Forms.LinkBehavior.HoverUnderline;
			this.linkLabelAbout.Location = new System.Drawing.Point(36, 0);
			this.linkLabelAbout.Name = "linkLabelAbout";
			this.linkLabelAbout.Size = new System.Drawing.Size(36, 28);
			this.linkLabelAbout.TabIndex = 1;
			this.linkLabelAbout.TabStop = true;
			this.linkLabelAbout.Text = "About";
			this.linkLabelAbout.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			this.linkLabelAbout.VisitedLinkColor = System.Drawing.Color.Blue;
			this.linkLabelAbout.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.linkLabelAbout_LinkClicked);
			// 
			// linkLabelFulLScreen
			// 
			this.linkLabelFulLScreen.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.linkLabelFulLScreen.BackColor = System.Drawing.Color.White;
			this.linkLabelFulLScreen.LinkBehavior = System.Windows.Forms.LinkBehavior.HoverUnderline;
			this.linkLabelFulLScreen.Location = new System.Drawing.Point(256, 0);
			this.linkLabelFulLScreen.Name = "linkLabelFulLScreen";
			this.linkLabelFulLScreen.Size = new System.Drawing.Size(64, 28);
			this.linkLabelFulLScreen.TabIndex = 7;
			this.linkLabelFulLScreen.TabStop = true;
			this.linkLabelFulLScreen.Text = "Full Screen";
			this.linkLabelFulLScreen.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			this.linkLabelFulLScreen.VisitedLinkColor = System.Drawing.Color.Blue;
			this.linkLabelFulLScreen.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.linkLabelFulLScreen_LinkClicked);
			// 
			// linkLabelPopOffOn
			// 
			this.linkLabelPopOffOn.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.linkLabelPopOffOn.BackColor = System.Drawing.Color.White;
			this.linkLabelPopOffOn.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.linkLabelPopOffOn.LinkBehavior = System.Windows.Forms.LinkBehavior.HoverUnderline;
			this.linkLabelPopOffOn.Location = new System.Drawing.Point(320, 0);
			this.linkLabelPopOffOn.Name = "linkLabelPopOffOn";
			this.linkLabelPopOffOn.Size = new System.Drawing.Size(40, 28);
			this.linkLabelPopOffOn.TabIndex = 8;
			this.linkLabelPopOffOn.TabStop = true;
			this.linkLabelPopOffOn.Text = ">>>";
			this.linkLabelPopOffOn.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			this.linkLabelPopOffOn.VisitedLinkColor = System.Drawing.Color.Blue;
			this.linkLabelPopOffOn.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.linkLabelPopOffOn_LinkClicked);
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.SystemColors.Control;
			this.ClientSize = new System.Drawing.Size(360, 338);
			this.Controls.Add(this.linkLabelPopOffOn);
			this.Controls.Add(this.linkLabelFulLScreen);
			this.Controls.Add(this.linkLabelAbout);
			this.Controls.Add(this.linkLabelExit);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.labelDivider);
			this.Controls.Add(this.statusBar1);
			this.Controls.Add(this.processingControl);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "MainForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Windows Forms Control Tricks (C#)";
			this.Resize += new System.EventHandler(this.MainForm_Resize);
			this.Closing += new System.ComponentModel.CancelEventHandler(this.MainForm_Closing);
			this.Load += new System.EventHandler(this.MainForm_Load);
			this.Move += new System.EventHandler(this.MainForm_Move);
			this.ResumeLayout(false);

		}
		#endregion

		#region Windows Forms Event Handlers

		private void MainForm_Load(object sender, System.EventArgs e)
		{
			processingControl.StartAnimation();
		}

		private void linkLabelAbout_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
		{
			new AboutForm().ShowDialog();
		}

		private void linkLabelExit_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
		{
			this.Close();
		}

		private void MainForm_Move(object sender, System.EventArgs e)
		{
			PositionPopOffForm();
		}

		private void MainForm_Resize(object sender, System.EventArgs e)
		{
			PositionPopOffForm();
		}

		private void linkLabelPopOffOn_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
		{
			if (linkLabelPopOffOn.Text == ">>>")
			{
				linkLabelPopOffOn.Text = "<<<";
				PopOffControl();
			}
			else
			{
				AddBackControl();
			}
		}

		private void linkLabelFulLScreen_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
		{
			if (!messagedOnce)
			{
				messagedOnce = true;

				string msg = "The application will now enter full screen mode. The control you see behind this\n" +
					"MessageBox will be transferred to the full screen form. Press <ESCAPE> to return.";
			
				MessageBox.Show(msg, this.Text, MessageBoxButtons.OK, MessageBoxIcon.Information);
			}

			ShowFullScreenForm();		
		}

		private void MainForm_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			if (popOffForm != null)
			{
				popOffForm.Close();
			}
		}

		#endregion

		#region Control Pop-on Pop-off Code

		private void PopOffControl()
		{
			if (popOffForm != null)
			{
				return;
			}

			popOffForm = new PopOffForm();
			popOffForm.FormClosing += new EventHandler(popOffForm_FormClosing);

			popOffForm.AddControl(processingControl);

			PositionPopOffForm();
			popOffForm.Show();

			linkLabelFulLScreen.Enabled = false;
		}

		private void AddBackControl()
		{
			if (popOffForm == null)
			{
				return;
			}

			//
			// This is a little indirect how this adding back of the control works.
			// Remeber that we signed up for the FormClosing event of the PopOffForm.
			// The reason for this is that they might just press the X on the toolbox 
			// form and we have to deal with that as well. So just let the event, which
			// will be fired anyway, cause our main form to grab the control back.
			//
		
			popOffForm.Close();
			popOffForm = null;
		}

		private void PositionPopOffForm()
		{
			if (popOffForm != null)
			{
				int screenWidth = System.Windows.Forms.Screen.PrimaryScreen.Bounds.Width;
				int right = Math.Min(this.Right + 10, screenWidth - popOffForm.Width);

				popOffForm.Location = new Point(right, this.Top + (this.Height - this.ClientSize.Height));
			}
		}

		/// <summary>
		///		When the pop off form closes, we want to get our rendering control
		///		back and add it to our main form. We recorded the previous location
		///		so we can add it back in the same size and shape as before.
		/// </summary>
		private void popOffForm_FormClosing(object sender, EventArgs e)
		{
			popOffForm = null;
			linkLabelPopOffOn.Text = ">>>";
			linkLabelFulLScreen.Enabled = true;
			
			ResetControlLayout();
		}

		private void ResetControlLayout()
		{
			processingControl.Dock = DockStyle.None;
			processingControl.Anchor = AnchorStyles.Top | AnchorStyles.Bottom | AnchorStyles.Right | AnchorStyles.Left;
			processingControl.Location = new Point(0, labelDivider.Bottom);
			processingControl.Size = new Size(ClientSize.Width, statusBar1.Top - labelDivider.Bottom);

			this.Controls.Add(processingControl);
			processingControl.Visible = true;
		}

		private void ShowFullScreenForm()
		{
			processingControl.Visible = false;
			this.Controls.Remove(processingControl);

			FullScreenForm frm = new FullScreenForm(processingControl);
			frm.ShowDialog();

			ResetControlLayout();
		}

		#endregion

	}
}
