Public Class PopOffForm
    Inherits System.Windows.Forms.Form

#Region "Member Variables and Events"

    '
    ' This event is fired when this form closes. This notifies the 
    ' main form that this form is just about to close. The main form
    ' will then grab the render control back from this form.
    '
    Public Event FormClosing As System.EventHandler

    Private ProcessingCtrl As Kennedy.Windows.ControlsTricks.ProcessingControl

#End Region

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        '
        'PopOffForm
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(274, 224)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow
        Me.Name = "PopOffForm"
        Me.ShowInTaskbar = False
        Me.StartPosition = System.Windows.Forms.FormStartPosition.Manual
        Me.Text = "Pop-off Toolbox View"
        Me.TopMost = True

    End Sub

#End Region

#Region "Control Management Code"

    Public Sub AddControl(ByVal Ctrl As Kennedy.Windows.ControlsTricks.ProcessingControl)

        Me.ProcessingCtrl = Ctrl
        Me.Controls.Add(Ctrl)
        Ctrl.Visible = True
        Ctrl.Dock = DockStyle.Fill

    End Sub

    Public Sub RemoveControl()

        If Me.ProcessingCtrl Is Nothing Then
            Return
        End If

        Me.Controls.Remove(ProcessingCtrl)
        ProcessingCtrl = Nothing

    End Sub

    Private Sub PopOffForm_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing

        RemoveControl()
        RaiseEvent FormClosing(Me, New EventArgs)

    End Sub

#End Region

End Class
